SystemOrganization addCategory: #'XPF-CodeMarker'!
SystemOrganization addCategory: #'XPF-MonticelloTest'!
SystemOrganization addCategory: #'XPF-OmniBrowserTest'!
SystemOrganization addCategory: #'XPF-Tests-Models'!
SystemOrganization addCategory: #'XPF-Models'!

!String methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/20/2009 17:17' foobar: foobar!
findAllStrings: aString
	"Returns a collection with all starting indices of the given string in me."
	
	|indices currentStartIndex|
	indices := Bag new.
	currentStartIndex := 1.
	
	[currentStartIndex := (self findString: aString startingAt: currentStartIndex) + 1.
		currentStartIndex > 1 
	] whileTrue: [indices add: currentStartIndex - 1].

	^indices.! !

!OBCmdMultiView methodsFor: '*XPF-CodeMarker' stamp: 'cs 1/15/2009 17:24' foobar: foobar!
execute
	|viewType|
	viewType := OBChoiceRequest labels: #(Source Bytecode Decompile PrettyPrint XPF).
	self styler: SHTextStylerST80 new.
	viewType ifNotNil: [self perform: (#toggle, viewType) asSymbol]! !

!OBCmdMultiView methodsFor: '*XPF-CodeMarker' stamp: 'cs 1/15/2009 17:24' foobar: foobar!
styler: styler
	| panel morph |
	
	panel := requestor browser panels 
		detect: [ :each | each isKindOf: OBDefinitionPanel ]
		ifNone: [ ^ self ].
	morph := OBPluggableTextMorph allSubInstances
		detect: [ :each | each model == panel ]
		ifNone: [ ^ self ].
	morph styler: (styler
		view: morph;
		yourself).! !

!OBCmdMultiView methodsFor: '*XPF-CodeMarker' stamp: 'cs 1/15/2009 17:22' foobar: foobar!
toggleXPF

	self styler: XPFTextStyler new.
	self setTextInDefinitionPanel: target source.! !

OBReadOnlyDefinition subclass: #XPOBRODefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-OmniBrowserTest'!

!XPOBRODefinition methodsFor: 'callbacks' stamp: 'cs 1/15/2009 17:01' foobar: foobar!
processText: aText
	^ 'Begin of meth', String cr, aText, String cr, 'End of Meth'! !

!XPOBRODefinition methodsFor: 'callbacks' stamp: 'topa 1/13/2009 19:29' foobar: foobar!
text
	^ self processText: text! !

PluggableTextMorph subclass: #XPFPluggableTextMorph
	instanceVariableNames: 'styler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-CodeMarker'!

!XPFPluggableTextMorph class methodsFor: 'instance creation' stamp: 'cs 1/13/2009 18:39' foobar: foobar!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel
	|styler answer stylerClass |
	answer := self new.
	stylerClass := Smalltalk classNamed: #XPFTextStyler "#SHTextStylerST80".
	styler := stylerClass
		ifNotNil:[
			stylerClass new
				view: answer;
				yourself].
	^ answer
		styler: styler;
		on: anObject
		text: getTextSel
		accept: setTextSel
		readSelection: getSelectionSel
		menu: getMenuSel! !

!XPFPluggableTextMorph methodsFor: 'styling' stamp: 'cs 1/13/2009 17:11' foobar: foobar!
okToStyle

	^self styler isNil not! !

!XPFPluggableTextMorph methodsFor: 'styling' stamp: 'cs 1/13/2009 18:46' foobar: foobar!
setText: aText

	self okToStyle ifFalse: [^super setText: aText].
	super setText: (styler format: aText).
	self styler style: textMorph contents.! !

!XPFPluggableTextMorph methodsFor: 'accessing' stamp: 'cs 1/13/2009 16:58' foobar: foobar!
styler
	^ styler! !

!XPFPluggableTextMorph methodsFor: 'accessing' stamp: 'cs 1/13/2009 16:58' foobar: foobar!
styler: anObject
	styler := anObject! !

!XPFPluggableTextMorph methodsFor: 'styling' stamp: 'cs 1/13/2009 17:28' foobar: foobar!
stylerStyled: styledCopyOfText

	textMorph contents runs: styledCopyOfText runs .
	"textMorph paragraph recomposeFrom: 1 to: textMorph contents size delta: 0."  "caused chars to appear in wrong order esp. in demo mode. remove this line when sure it is fixed"
	textMorph updateFromParagraph.
	selectionInterval 
		ifNotNil:[
			textMorph editor
				selectInvisiblyFrom: selectionInterval first to: selectionInterval last;
				storeSelectionInParagraph;
				setEmphasisHere].
	self scrollSelectionIntoView! !

TestCase subclass: #XPFTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Tests-Models'!

!XPFTestCase class methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 11:46' foobar: foobar!
isAbstract
 	^self name = #XPFTestCase! !

!XPFTestCase methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 11:34' foobar: foobar!
checkAccessor: aSelector on: aTargetObject with: anObject
	"test getter/setter aSelector of aTargetObject with anObject"
	
	aTargetObject perform: aSelector asMutator with: anObject.
	self
		assert: (aTargetObject perform: aSelector) == anObject
		! !

XPFTestCase subclass: #XPFUserStoryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Tests-Models'!

!XPFUserStoryTest methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 11:26' foobar: foobar!
setUp! !

!XPFUserStoryTest methodsFor: 'as yet unclassified' stamp: 'SR 1/22/2009 12:18' foobar: foobar!
testAttributes
	| us |
	us := XPFUserStory new.
	self
		checkAccessor: #storyName on: us with: 'US + Tasks verwalten';
		checkAccessor: #storyDescription on: us with: 'Dinge tun und Sachen machen';
		checkAccessor: #storyPriority on: us with:'High';
		checkAccessor: #storyAcceptanceCriteria on: us with: 'Es geht';
		checkAccessor: #storyEstimate on: us  with: '10';
		checkAccessor: #storyActual on: us  with: '12'.
! !

Object subclass: #XPFUserStory
	instanceVariableNames: 'storyName storyDescription storyPriority storyAcceptanceCriteria storyEstimate storyActual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-Models'!

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:04' foobar: foobar!
storyAcceptanceCriteria
	^ storyAcceptanceCriteria! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:04' foobar: foobar!
storyAcceptanceCriteria: anObject
	storyAcceptanceCriteria := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:04' foobar: foobar!
storyActual
	^ storyActual! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:04' foobar: foobar!
storyActual: anObject
	storyActual := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyDescription
	^ storyDescription! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyDescription: anObject
	storyDescription := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyEstimate
	^ storyEstimate! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyEstimate: anObject
	storyEstimate := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyName
	^ storyName! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyName: anObject
	storyName := anObject! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyPriority
	^ storyPriority! !

!XPFUserStory methodsFor: 'accessing' stamp: 'SR 1/22/2009 12:05' foobar: foobar!
storyPriority: anObject
	storyPriority := anObject! !

!MCStWriter methodsFor: '*XPF' stamp: 'mt 1/13/2009 18:31' foobar: foobar!
writeMethodPreamble: definition
	stream
		cr;
		nextPut: $!!;
		nextPutAll: definition fullClassName;
		nextPutAll: ' methodsFor: ';
		nextPutAll: definition category asString printString;
		nextPutAll: ' stamp: ';
		nextPutAll: definition timeStamp asString printString;
		nextPutAll: ' foobar: ';
		nextPutAll: definition foobar;
		nextPutAll: '!!';
		cr! !

!MCMethodDefinition methodsFor: '*XPF' stamp: 'mt 1/13/2009 18:30' foobar: foobar!
foobar
	^'foobar'! !

SHTextStyler subclass: #XPFTextStyler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-CodeMarker'!

!XPFTextStyler methodsFor: 'accessing' stamp: 'cs 1/15/2009 17:16' foobar: foobar!
classOrMetaClass: aBehavior! !

!XPFTextStyler methodsFor: 'private' stamp: 'cs 1/13/2009 18:55' foobar: foobar!
privateFormat: aText

	^ aText copyReplaceTokens: 'uuu' with: 'X'! !

!XPFTextStyler methodsFor: 'private' stamp: 'cs 1/15/2009 18:08' foobar: foobar!
privateStyle: aText
	
	aText addAttribute: TextColor green from: 1 to: 3.! !

!MultiNewParagraph methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/20/2009 18:10' foobar: foobar!
displayOn: aCanvas using: displayScanner at: somePosition 
	"Send all visible lines to the displayScanner for display"
	| visibleRectangle offset leftInRun line |
	visibleRectangle := aCanvas clipRect.
	offset := somePosition - positionWhenComposed.
	leftInRun := 0.
	(self lineIndexForPoint: visibleRectangle topLeft) 
		to: (self lineIndexForPoint: visibleRectangle bottomRight)
		do: 
			[ :i | 
			line := lines at: i.
			self 
				highlightFooOn: aCanvas	at: line;
				displaySelectionInLine: line on: aCanvas.
			line first <= line last ifTrue: 
				[ leftInRun := displayScanner 
					displayLine: line
					offset: offset
					leftInRun: leftInRun ] ]! !

!MultiNewParagraph methodsFor: '*XPF-CodeMarker' stamp: 'mt 1/20/2009 18:08' foobar: foobar!
highlightFooOn: aCanvas at: line 
	| cb1 cb2 |
	
	((self text string atAll: (line first to: line last)) 
		findAllStrings: 'foo') do: [ :each | 
			cb1 := self characterBlockForIndex: each + (line first - 1).
			cb2 := self characterBlockForIndex: each + (line first - 1) + 3.
			aCanvas 
				fillRectangle: (cb1 left @ line top corner: cb2 left @ line bottom)
				color: Color green ].! !

Morph subclass: #MyClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XPF-MonticelloTest'!

!MyClass methodsFor: 'as yet unclassified' stamp: 'mt 1/13/2009 18:30' foobar: foobar!
initialize
	super initialize.
	self color: Color green! !
